<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8"/>
    <title>API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
<nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
    <a class="navbar-brand" href="#">API</a>
</nav>
<div class="container-fluid">
    <div class="row" style="min-height: 93.8vh">
        <div class="col-md-2 bg-white shadow">
            <div class="list-group mt-3">
                <a href="/user/index" class="list-group-item list-group-item-action ">User</a>
                <a href="/login/index" class="list-group-item list-group-item-action ">Login</a>
            </div>
        </div>
        <div class="col-md-10">
            <div class="card mt-3">
                <div class="card-body shadow">
                    <h2> API</h2>
                    <p>
                        <button class="btn btn-primary" onclick="OpenList(0, 5)">Open List</button>
                        <button class="btn btn-primary" onclick="OpenForm()">Open Add Form</button>
                    </p>
                    <input class="form-control" type="text" placeholder="Search" onkeyup="SearchUser(this.value)"
                           autocomplete="off">
                    <div id="userList"></div>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="/js/jquery-3.5.1.min.js"></script>
<script src="/js/bootstrap-bundle.min.js"></script>

<script>
    function OpenList() {
        $.ajax({
            url: '/api/user',
            type: 'get',
            contentType: 'application/json',
            success: function(data) {
                var table = '<table class="table table-hover">';

                table += "<tr>";
                table += "<th> # </th>";
                table += "<th> username </th>";
                table += "<th> Email </th>";
                table += "<th> Password</th>";
                table += "<th> Action</th>";
                table += "</tr>";

                for (let i = 0; i < data.length; i++) {
                    table += "<tr>";
                    table += "<td>" + (i + 1) + "</td>";
                    table += "<td>" + data[i].username + "</td>";
                    table += "<td>" + data[i].email + "</td>";
                    table += "<td>" + data[i].password + "</td>";
                    table += "<td><button class='btn btn-success' value='" + data[i].id + "' onclick='formEdit(this.value)'>Update</button> " + ' '
                    table += "</tr>"
                }
                table += "</table>";
                $('#userList').html(table);
            }
        });
    }

    function OpenForm() {
        $.ajax({
            url: '/api/user',
            type: 'GET',
            contentType: 'application/json',
            success: function(data) {
                var form = '<table class="table table-bordered"';
                form += "<tr>";
                form += "<td>username</td>";
                form += '<td><input class="form-control" type ="text" id="username"></td>';
                form += "</tr>";
                form += "<tr>";
                form += "<td>Email</td>";
                form += '<td><input class="form-control" type ="text" id="email"></td>';
                form += "</tr>";
                form += "<tr>";
                form += "<td>Password</td>";
                form += '<td><input class="form-control" type ="password" id="password"></td>';
                form += "</tr>";
                form += "<tr>";
                form += '<td colspan="2"><button class="btn btn-primary" onclick = "SaveUser(this.value)">Save</button></td>';
                form += '</tr>';
                $("#userList").html(form);
            }
        });
    }

    function SaveUser() {
        var formData = '{';
        formData += '"username":"' + $('#username').val() + '",';
        formData += '"email":"' + $('#email').val() + '",';
        formData += '"password":"' + $('#password').val() + '"';
        formData += '}';

        $.ajax({
            url: '/api/user',
            type: 'post',
            contentType: 'application/json',
            data: formData,
            success: function(data) {
                OpenList(0, 5);


                    var formDataLogin = '{';
                    formDataLogin += '"email":"' + $('#email').val() + '",';
                    formDataLogin += '"password":"' + $('#password').val() + '"';
                    formDataLogin += '}';

                    $.ajax({
                        url: '/api/login',
                        type: 'post',
                        contentType: 'application/json',
                        data: formDataLogin,
                        success: function(data) {
                            OpenList(0, 5);
                        }

                    });
            }
        });
    }

    function formEdit(id) {
        $.ajax({
        url: '/api/user/' + id,
        type: 'get',
        contentType: 'application/json',
        success: function(data) {
            var form = '<table class="table table-bordered">';
            form += "<tr>";
                form += "<td>username</td>";
                form += "<td><input class='form-control' type='text' id='username' value='" + data.username + "'><input class='form-control' type='hidden' id='createdOn' value='" + data.createdOn + "'></td>"
                form += "</tr>";
                form += "<tr>";
                form += "<td>email</td>";
                form += "<td><input class='form-control' type='text' id='email' value='" + data.email + "'><input class='form-control' type='hidden' id='createdBy' value='" + data.createdBy + "'></td>"
                form += "</tr>";
                form += "<tr>";
                form += "<td>Password</td>";
                form += '<td><input class="form-control" type="password" id="password" value="' + data.password + '"></td>';
                form += "</tr>";
                form += "<tr>";
                form += '<td colspan="2"><button class="btn btn-primary" value="' + data.id + '" onclick="UpdateUser(this.value)">Save</button></td>';
                form += '</tr>';
                $('#userList').html(form);
            }
        });
    }

    function UpdateUser(id) {
        var formData = '{';
        formData += '"username":"' + $('#username').val() + '",';
        formData += '"email":"' + $('#email').val() + '",';
        formData += '"password":"' + $('#password').val() + '",';
        formData += '"createdBy":"' + $('#createdBy').val() + '",'
        formData += '"createdOn":"' + $('#createdOn').val() + '"'
        formData += '}';

        $.ajax({
            url: '/api/user/' + id,
            type: 'put',
            contentType: 'application/json',
            data: formData,
            success: function(data) {
                OpenList();
            }
        });
    }
</script>